diff --git a/Source/Lib/Encoder/Codec/EbEntropyCodingProcess.c b/Source/Lib/Encoder/Codec/EbEntropyCodingProcess.c
index 93c47ae64d..a4f7f177b4 100644
--- a/Source/Lib/Encoder/Codec/EbEntropyCodingProcess.c
+++ b/Source/Lib/Encoder/Codec/EbEntropyCodingProcess.c
@@ -584,6 +584,9 @@ void *entropy_coding_kernel(void *input_ptr) {
                                      cm->tiles_info.tile_col_start_mi[tile_col]) >>
                                     scs_ptr->seq_header.sb_size_log2;
 
+#if R2R_FIX
+        EbBool frame_entropy_done = EB_FALSE;
+#endif
         {
             initial_process_call = EB_TRUE;
             y_sb_index           = rest_results_ptr->completed_sb_row_index_start;
@@ -740,6 +743,9 @@ void *entropy_coding_kernel(void *input_ptr) {
                                     eb_release_object(pcs_ptr->ref_pic_ptr_array[1][ref_idx]);
                             }
 
+#if R2R_FIX
+                            frame_entropy_done = EB_TRUE;
+#else
                             // Get Empty Entropy Coding Results
                             eb_get_empty_object(context_ptr->entropy_coding_output_fifo_ptr,
                                                 &entropy_coding_results_wrapper_ptr);
@@ -751,11 +757,29 @@ void *entropy_coding_kernel(void *input_ptr) {
 
                             // Post EntropyCoding Results
                             eb_post_full_object(entropy_coding_results_wrapper_ptr);
+#endif
                         }
                     } // End if(PictureCompleteFlag)
                 }
                 eb_release_mutex(pcs_ptr->entropy_coding_info[tile_idx]->entropy_coding_mutex);
             }
+#if R2R_FIX
+            // Move the post here.
+            // In some cases, PAK ends fast, pcs will be released before we quit the while-loop
+            if (frame_entropy_done) {
+                // Get Empty Entropy Coding Results
+                eb_get_empty_object(context_ptr->entropy_coding_output_fifo_ptr,
+                        &entropy_coding_results_wrapper_ptr);
+                entropy_coding_results_ptr =
+                    (EntropyCodingResults *)
+                    entropy_coding_results_wrapper_ptr->object_ptr;
+                entropy_coding_results_ptr->pcs_wrapper_ptr =
+                    rest_results_ptr->pcs_wrapper_ptr;
+
+                // Post EntropyCoding Results
+                eb_post_full_object(entropy_coding_results_wrapper_ptr);
+            }
+#endif
         }
 #else
         if (pcs_ptr->parent_pcs_ptr->av1_cm->tiles_info.tile_cols *
